#ifndef __zlog_ex_h
#define __zlog_ex_h

#ifdef __cplusplus
extern "C"
{
#endif

#include <zlog.h>

    enum
    {
        ZLOG_LEVEL_COUT = 30,
        ZLOG_LEVEL_CSYS = 70,
        ZLOG_LEVEL_CERR = 90,
    };

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#define dzlog_cout(...)                             \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_COUT, __VA_ARGS__)

#define dzlog_csys(...)                             \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_CSYS, __VA_ARGS__)

#define dzlog_cerr(...)                             \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_CERR, __VA_ARGS__)

#elif defined __GNUC__
#define dzlog_cout(format, args...)                 \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_COUT, format, ##args)

#define dzlog_csys(format, args...)                 \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_CSYS, format, ##args)

#define dzlog_cerr(format, args...)                 \
    dzlog(__FILE__, sizeof(__FILE__) - 1,           \
          __func__, sizeof(__func__) - 1, __LINE__, \
          ZLOG_LEVEL_CERR, format, ##args)
#endif

    /* 
    config为NULL的情况（建议）： 使用默认配置(/etc/zlog.conf)，
    config不为NULL的情况： 需要自己定义cout/csys/cerr，否则这三个等级无法使用，可参考默认配置的定义。
    project_name建议为项目名称；program_name建议为二进制程序名。这两个值分别对应mdc中的PROJECT_NAME和PROGRAM_NAME
    */
    int dzlog_init_ex(const char *config,
                      const char *cname,
                      const char *project_name,
                      const char *program_name);

#ifdef __cplusplus
}
#endif

#endif